title;
options ls=120 nocenter;
options nodate nonumber;

proc IML;

start approx;
f0 = .01;
f1 = .01;
f2 = .03;
u = .4;
link calc;
u = .15;
link calc;
f2 = .8;
u = .4;
link calc;
f2 = .8;
u = .15;
link calc;
print "Comparison with dependent case when no residual";
f0=.1366;
f1=.1366;
f2=.0367;
f0=.2191;
f1=.1045;
f2=.0411;
u=0.4;
link calc;
stop;

calc:
v = 1 - u;
d = 1;
h = 0;
h2 = h * h;
kp = u**2*f0 + 2*u*v*f1 + v**2*f2;

u2 = u * u;
u3 = u2 * u;
u4 = u3 * u;
v2 = v * v;
v3 = v2 * v;
v4 = v3 * v;

p=j(9,1,0);
x1=j(9,1,0);
x2=j(9,1,0);
xd=j(9,1,0);
mz=j(9,1,0);
dz=j(9,1,0);
uu=j(9,1,0);
p[1] = (1 - f0) * f0;
p[2] = (1 - f1) * f0;
p[3] = (1 - f2) * f0;
p[4] = (1 - f0) * f1;
p[5] = (1 - f1) * f1;
p[6] = (1 - f2) * f1;
p[7] = (1 - f0) * f2;
p[8] = (1 - f1) * f2;
p[9] = (1 - f2) * f2;

x1[1] = d; x2[1] = d; xd[1] = x1[1] - x2[1];
x1[2] = d; x2[2] = h; xd[2] = x1[2] - x2[2];
x1[3] = d; x2[3] = -d; xd[2] = x1[3] - x2[3];
x1[4] = h; x2[4] = d; xd[2] = x1[4] - x2[4];
x1[5] = h; x2[5] = -h; xd[2] = x1[5] - x2[5];
x1[6] = h; x2[6] = d; xd[2] = x1[6] - x2[6];
x1[7] = -d; x2[7] = d; xd[2] = x1[7] - x2[7];
x1[8] = -d; x2[8] = h; xd[2] = x1[8] - x2[8];
x1[9] = -d; x2[9] = -d; xd[2] = x1[9] - x2[9];

mz[1] = u2;
mz[5] = 2 * u * v;
mz[9] = v2;

dz[1] = u4 + u3 * v + u2 * v2 / 4;
dz[2] = u3 * v + u2 * v2 / 2;
dz[3] = u2 * v2 / 4;
dz[4] = u3 * v + u2 * v2 / 2;
dz[5] = u3 * v + 3 * u2 * v2 + u * v3;
dz[6] = u2 * v2 / 2 + u * v3;
dz[7] = u2 * v2 / 4;
dz[8] = u2 * v2 / 2 + u * v3;
dz[9] = u2 * v2 / 4 + u * v3 + v4;

uu[1] = u4;
uu[2] = 2 * u3 * v;
uu[3] = u2 * v2;
uu[4] = 2 * u3 * v;
uu[5] = 4 * u2 * v2;
uu[6] = 2 * u * v3;
uu[7] = u2 * v2;
uu[8] = 2 * u * v3;
uu[9] = v4;

Pg=j(9,1,0);
Ps=j(9,1,0);
s = 0;
do g = 1 TO 9;
  pg[g] = p[g] * dz[g];
  s = s + pg[g];
end;

do g = 1 TO 9;
  Ps[g] = pg[g] / s;
end;

b = Ps[4] + Ps[7] + Ps[8];
c = Ps[2] + Ps[3] + Ps[6];

x2 = (b - c) ** 2 / (b + c);

n01=14.88/x2;
n001=20.9/x2;
PRINT
       f0
       f1
       f2
        u
       kp [format=5.4]
       x2 [format=6.2]
      n01 [format=8.0]
     n001 [format=8.0];

return;

finish approx;

print 'Estimates assmuing independence';
/*it gives the same answer as QBASIC*/
run approx;

/*------ Newton's Method to Solve a Nonlinear Function --------*/
/* The user must supply initial values, and the FUN and DERIV  */
/* functions.                                                  */
/* On entry: FUN evaluates the function F in terms of X        */
/*           initial values are given to X                     */
/*           DERIV evaluates jacobian J                        */
/*           Tuning Variables: CONVERGE, MAXITER.              */
/* On exit:  solution in X, function value in F close to zero  */
/*           ITER has number of iterations.                    */
/*-------------------------------------------------------------*/

START NEWTON;
  RUN FUN;                /* EVALUATE FUNCTION AT STARTING VALUES */
  DO ITER=1 TO MAXITER    /* ITERATE UNTIL MAXITER ITERATIONS */
     WHILE(MAX(ABS(F))>CONVERGE); /* OR CONVERGENCE           */
     RUN DERIV;           /* EVALUATE DERIVATIVES IN J        */
     DELTA=-f/j;          /* CORRECTION VECTOR SOLVE(J,F);    */
     X=X+DELTA;           /* THE NEW APPROXIMATION            */
     RUN FUN;             /* EVALUATE THE FUNCTION            */
  END;
FINISH;

MAXITER=1000;               /* DEFAULT MAXIMUM ITERATIONS    */
CONVERGE=.0000000000001;    /* DEFAULT CONVERGENCE CRITERION */

START FUN;
  X1=X[1];
  t0=(x1-m[1])/sd;
  t1=(x1-m[2])/sd;
  t2=(x1-m[3])/sd;
/*
  f=tmp;
  use f^2 by Pak
*/
  tmp=u**2*CDF('norm',t0)+2*u*v*CDF('norm',t1)+v**2*CDF('norm',t2)-1+k;
  f=tmp*tmp;
FINISH;

START DERIV;
/*
  omit 2*tmp
  add sd by Pak
*/
  J=2*tmp*(u**2*probnorm(t0)+2*u*v*probnorm(t1)+v**2*probnorm(t2))/sd;
FINISH;

start bnorm;
/*
  to use cdf/probbnrm

  Effect size of QTL (Mather-Jinks notation)
  Effects of genotypes AA, Aa, aa are d, h, -d
           d = 1
           h = dominance usually between -1 and 1
           u = Frequency of A (increaser) allele
    total h2 = Total heritability
      qtl h2 = QTL heritability
utail, ltail = Tail probabilities, as prevalences k
*/

d = 1;
h = 0;
u = .4;
qtlh2=0.05;
totalh2=0.5;
utail = .01;
ltail = .50;
link calc;

qtlh2=0.1;
link calc;

qtlh2=0.15;
link calc;

print "Comparison with independent case with residual";
qtlh2=0.1;
totalh2=0.1;
u = .4;
utail = .1;
ltail = .9;
link calc;
stop;

calc:
/*
  house-keeping
*/
v = 1 - u;

h2 = h * h;
u2 = u * u;
u3 = u2 * u;
u4 = u3 * u;
v2 = v * v;
v3 = v2 * v;
v4 = v3 * v;

/*
  vt = var(total)
  vq = var(QTL)
  vg = var(genetic)
  vr = var(r)
   r = residual
  mu = mean(QTL)
   m = genotypic means
*/

mu=u2*d+2*u*v*h+v2*(-d);
vq=2*u*v*(d+(v-u)*h)**2 + 4*u2*v2*h2;
vg=vq*totalh2/qtlh2;
vt=vg/totalh2;
vr=vt-vq;
sd=sqrt(vr);
r=(vg-vq)/vr/2;

m=j(3,1,0);
m[1]=d+mu;
m[2]=h+mu;
m[3]=-d+mu;

/*
  obtain thresholds t[.] by iteration
*/

t=j(2,1,0);
fx=j(2,1,0);
DO;
  X={-1};
  k=1-ltail;
  RUN NEWTON;
  t[1]=x;
  fx[1]=f;
  X={5};
  k=utail;
  RUN NEWTON;
  t[2]=x;
  fx[2]=f;
END;

/*
  Obtain individual penetrances for reference only
  Note joint penetrance not product of individual penetrance
  pen(threshold=1,2,genotype=AA,Aa,aa)
*/

pen=j(2,3,0);
do i=1 to 2;
   do j=1 to 3;
      z=(t[i]-m[j])/sd;
      pen[i,j] = 1-cdf('norm',z);
   end;
end;

/*
  obtains upper left quadrant
  so sib 1 below lower threshold, sib 2 above upper threshold
  in order as follows

  AA x AA
  AA x Aa
  AA x aa
  Aa x AA
  Aa x Aa
  Aa x aa
  aa x AA
  aa x Aa
  aa x aa

*/

p=j(9,1,0);
do i=1 to 3;
  do j=1 to 3;
     z1=(t[1]-m[i])/sd;
     z2=(t[2]-m[j])/sd;
     p[(i-1)*3+j]=cdf('norm',z1)-probbnrm(z1,z2,r);
  end;
end;

dz=j(9,1,0);
dz[1] = u4 + u3 * v + u2 * v2 / 4;
dz[2] = u3 * v + u2 * v2 / 2;
dz[3] = u2 * v2 / 4;
dz[4] = u3 * v + u2 * v2 / 2;
dz[5] = u3 * v + 3 * u2 * v2 + u * v3;
dz[6] = u2 * v2 / 2 + u * v3;
dz[7] = u2 * v2 / 4;
dz[8] = u2 * v2 / 2 + u * v3;
dz[9] = u2 * v2 / 4 + u * v3 + v4;

Pg=j(9,1,0);
Ps=j(9,1,0);
s = 0;
do g = 1 TO 9;
   pg[g] = p[g] * dz[g];
   s = s + pg[g];
end;

do g = 1 TO 9;
   Ps[g] = pg[g] / s;
end;

b = Ps[4] + Ps[7] + Ps[8];
c = Ps[2] + Ps[3] + Ps[6];

x2 = (b - c) ** 2 / (b + c);

n01=14.88/x2;
n001=20.9/x2;
rr=j(2,2,0);
do;
  kp=j(2,1,0);
  f0=pen[1,1];
  f1=pen[1,2];
  f2=pen[1,3];
  rr[1,1]=f0/f2;
  rr[1,2]=f1/f2;
  kp[1] = u**2*f0 + 2*u*v*f1 + v**2*f2;
  f0=pen[2,1];
  f1=pen[2,2];
  f2=pen[2,3];
  rr[2,1]=f0/f2;
  rr[2,2]=f1/f2;
  kp[2] = u**2*f0 + 2*u*v*f1 + v**2*f2;
  PRINT
         qtlh2 [format=3.2]
       totalh2 [format=3.2]
             h [format=3.2]
             u [format=3.2]
             t [format=6.4]
            fx [format=9.6]
            x2 [format=6.2]
           pen [format=5.4]
            kp [format=5.4]
           n01 [format=6.0]
          n001 [format=6.0];
    PRINT
            rr [format=6.2]
            vt [format=5.2]
            vq [format=5.2]
            vg [format=5.2]
            vr [format=5.2]
             r [format=5.2]
            mu [format=5.2]
            sd [format=5.2]
         ltail 
         utail;
END;

return;
finish bnorm;

print 'Estimates allowing for dependence';
run bnorm;

quit;
